from vcCommand import *
import xml.etree.ElementTree as xml 
import vcVector
import vcMatrix
 
app = getApplication()
cmd = getCommand()

def setProperty(c,p):
  if not p.attrib['Value']:
    return
  pname = p.attrib['Name']
  cp = c.getProperty(pname)
  if not cp:
    print 'No such property <%s>' % pname
    return
  if cp.Type == VC_VECTOR:
    v = vcVector.new()
    v.X = eval(p.attrib['Value.X'])
    v.Y = eval(p.attrib['Value.Y'])
    v.Z = eval(p.attrib['Value.Z'])
    v.Z = eval(p.attrib['Value.W'])
    cp.Value = v
  elif cp.Type == VC_MATRIX:
    m = vcMatrix.new()
    n = vcVector.new()
    o = vcVector.new()
    a = vcVector.new()
    p = vcVector.new()
    n.X = eval(p.attrib['Value.Nx'])
    n.Y = eval(p.attrib['Value.Ny'])
    n.Z = eval(p.attrib['Value.Nz'])
    n.W = eval(p.attrib['Value.Nw'])
    o.X = eval(p.attrib['Value.Ox'])
    o.Y = eval(p.attrib['Value.Oy'])
    o.Z = eval(p.attrib['Value.Oz'])
    o.W = eval(p.attrib['Value.Ow'])
    a.X = eval(p.attrib['Value.Ax'])
    a.Y = eval(p.attrib['Value.Ay'])
    a.Z = eval(p.attrib['Value.Az'])
    a.W = eval(p.attrib['Value.Aw'])
    p.X = eval(p.attrib['Value.Px'])
    p.Y = eval(p.attrib['Value.Py'])
    p.Z = eval(p.attrib['Value.Pz'])
    p.W = eval(p.attrib['Value.Pw'])
    m.N = n
    m.O = o
    m.A = a
    m.P = p
    m.uniform() # ?
    cp.Value = m
  elif cp.Type == VC_STRING:
    cp.Value = p.attrib['Value']
  else:
    try:
      cp.Value = eval(p.attrib['Value'])
    except:
      print 'Error setting ', cp.Name, ' of type ', cp.Type, ' value ', cp.Value

def state1():
  filename = cmd.FileName
  if not filename:
    opencmd = app.findCommand("dialogOpen")
    uri = ""
    ok = True
    filter = "Model File (*.xml)|*.xml"
    opencmd.execute(uri,ok,filter)
    if not opencmd.Param_2:
      print "No file selected for importing, aborting command"
      return
    uri = opencmd.Param_1
    filename = uri[8:len(uri)]
    
  components = xml.parse(filename).getroot().find('Components')
  connections = xml.parse(filename).getroot().find('Connections')
  attachments = xml.parse(filename).getroot().find('Attachments')
  
  m = vcMatrix.new()
  n = vcVector.new()
  o = vcVector.new()
  a = vcVector.new()
  p = vcVector.new()
  wpr = vcVector.new()
  cimap = {}
  for component in components.findall('Component'):
    vcid = component.attrib['GlobalIdentity']
    name = component.attrib['Name']
    c = app.load('vcid:' + vcid)
    if c == None:
      print 'Failed to load : "{0}" vcid "{1}"'.format(name,vcid)
    else:
      print '  -  Loaded : "{0}" vcid "{1}"'.format(name,vcid)
      cimap[component.attrib['LocalIdentity']] = c
      #c.Name = name
      loc = component.find('Location')
      n.X = eval(loc.attrib['Nx'])
      n.Y = eval(loc.attrib['Ny'])
      n.Z = eval(loc.attrib['Nz'])
      n.W = eval(loc.attrib['Nw'])
      o.X = eval(loc.attrib['Ox'])
      o.Y = eval(loc.attrib['Oy'])
      o.Z = eval(loc.attrib['Oz'])
      o.W = eval(loc.attrib['Ow'])
      a.X = eval(loc.attrib['Ax'])
      a.Y = eval(loc.attrib['Ay'])
      a.Z = eval(loc.attrib['Az'])
      a.W = eval(loc.attrib['Aw'])
      p.X = eval(loc.attrib['Px'])
      p.Y = eval(loc.attrib['Py'])
      p.Z = eval(loc.attrib['Pz'])
      p.W = eval(loc.attrib['Pw'])
      m.N = n
      m.O = o
      m.A = a
      m.P = p
      m.uniform()
      c.PositionMatrix = m
      props = component.find('Properties')
      for prop in props.findall('Property'):
        setProperty(c,prop)
  c.rebuild()
  #print cimap
  for connection in connections.findall('Connection'):
    fromcomponent = cimap[connection.attrib['FromComponent']]
    tocomponent = cimap[connection.attrib['ToComponent']]
    frominterface = fromcomponent.findBehaviour(connection.attrib['FromInterface'])
    tointerface = tocomponent.findBehaviour(connection.attrib['ToInterface'])
    if not fromcomponent or not tocomponent or not frominterface or not tointerface:
      print 'Connection items not found for ', connection.attrib['FromComponent'], connection.attrib['FromInterface'], connection.attrib['ToComponent'], connection.attrib['ToInterface']
    else:
      if tointerface in [x.Interface for x in frominterface.ConnectedToSections]:
        pass # already connected...
      else:
        if not frominterface.connect(tointerface):
          print 'Failed to connect : ', fromcomponent.Name, '\'s interface ', frominterface.Name, ' to ', tocomponent.Name, '\'s interface ', tointerface.Name
        else:
          print '  -  Connected : interface "{0}" of component "{1}" to interface "{2}" of component "{3}" '.format(frominterface.Name,fromcomponent.Name,tointerface.Name,tocomponent.Name)
  print '\n'
  for attachment in attachments.findall('Attachment'):
    for connection in connections.findall('Connection'):
      conlist = [connection.attrib['FromComponent'],connection.attrib['ToComponent']]
      if attachment.attrib['ParentComponent'] in conlist and attachment.attrib['ChildComponent'] in conlist:
        pass # connected via interface 
      else:    
        pid = attachment.attrib['ParentComponent']
        if pid in cimap:
          parentcomponent = cimap[pid]
          parentnode = parentcomponent.findNode(attachment.attrib['ParentNodeName'])
        else:
          break
        cid = attachment.attrib['ChildComponent']
        if cid in cimap:
          childcomponent  = cimap[cid]
        else:
          break
        print '  -  Attached : "{0}" to node "{1}" of component "{2}" '.format(childcomponent.Name,parentnode.Name, parentcomponent.Name)
        
        #retain the position of attached node in 3D world 
        wpm = childcomponent.WorldPositionMatrix
        invMtx = parentnode.InverseWorldPositionMatrix
        m = invMtx * wpm
        parentnode.attach(childcomponent, True)
        childcomponent.PositionMatrix = m
        childcomponent.rebuild()
  app.render()


addState(state1)